// Implementacin de la clase que usa un hilo para mostrar una animacin:
// V 1.0 (C) Julio 2012 Salvador Pozo : Con Clase : http://conclase.net

#include <cstdio>
#include "hilotunel.h"

void Tunel::Mostrar() const {
    COORD dwPos = {0, 1};
    char cad[] =  "********************************************************************************";
    char contador[10];
    int l1, l2;

    l1 = centro-ancho/2;
    l2 = 80-l1-ancho;

    SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), dwPos);
    WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), cad, l1, 0, 0);
    dwPos.X = l1+ancho;
    SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), dwPos);
    WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), cad, l2, 0, 0);
    dwPos.X = 10;
    dwPos.Y = 0;
    sprintf(contador, "%09d", cuenta);
    SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), dwPos);
    WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), contador, 9, 0, 0);
}

void Tunel::Siguiente() {
    SMALL_RECT re1 = {0, 1, 79, 24};
    COORD coor = {0, 2};
    CHAR_INFO ci = { {' '}, FOREGROUND_BLUE+FOREGROUND_GREEN+FOREGROUND_RED};

    ScrollConsoleScreenBuffer(GetStdHandle(STD_OUTPUT_HANDLE), &re1, 0, coor, &ci);
    ancho += (5*rand()/RAND_MAX)-2;
    if(ancho < 2) ancho = 2;
    if(ancho > 15) ancho = 15;
    centro += (3*rand()/RAND_MAX)-1;
    if(centro < 1) centro = 1;
    if(centro+ancho > 79) centro = 79-ancho;
    cuenta++;
}

void Tunel::BorrarNave() {
    COORD c1 = {xn, yn};

    SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), c1);
    printf(" ");
}

void Tunel::MostrarNave() {
    COORD c1 = {xn, yn};

    SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), c1);
    printf("\xa4");
}

void Tunel::ProcesaTeclas() {
    if(dir.arriba && yn > 0) yn--;
    if(dir.abajo  && yn < 25) yn++;
    if(dir.izquierda && xn > 0) xn--;
    if(dir.derecha   && xn < 79) xn++;
}

bool Tunel::Colision() {
    CHAR_INFO ci[1];
    COORD tam = {1,1};
    COORD bcoor = {0,0};
    SMALL_RECT re = {xn, yn, xn, yn};

    ReadConsoleOutput(GetStdHandle(STD_OUTPUT_HANDLE), ci, tam, bcoor, &re);
    if(ci[0].Char.AsciiChar != ' ') return true;
    return false;
}

void Tunel::Explosion() {
    COORD c1 = {xn, yn};

    SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), c1);
    printf("X");
    dir.escape = true;
}

DWORD WINAPI Tunel::hiloTunel( void* par) {
    Tunel *tunel = (Tunel*)par;

    do {
        if(tunel->Reservar()) {
            tunel->BorrarNave();
            tunel->ProcesaTeclas();
            tunel->Siguiente();
            tunel->Mostrar();
            if(!tunel->Colision()) tunel->MostrarNave();
            else tunel->Explosion();
            tunel->Liberar();
            tunel->Esperar();
        }
    } while(!tunel->Salir());
    return 0;
}

DWORD WINAPI Tunel::hiloTeclado( void* par) {
    Tunel *tunel = (Tunel*)par;

    do {
        tunel->dir.arriba    = GetAsyncKeyState(VK_UP);
        tunel->dir.abajo     = GetAsyncKeyState(VK_DOWN);
        tunel->dir.izquierda = GetAsyncKeyState(VK_LEFT);
        tunel->dir.derecha   = GetAsyncKeyState(VK_RIGHT);
        tunel->dir.escape    = GetAsyncKeyState(VK_ESCAPE);
    } while (!tunel->dir.escape);

    return 0;
}
