// Clase que usa un hilo para mostrar una animacin en las coordenadas indicadas:
// V 1.0 (C) Julio 2012 Salvador Pozo : Con Clase : http://conclase.net

#ifndef __HILOTUNEL_H__
#define __HILOTUNEL_H__

#include <cstring>
#include "hilopantalla.h"

struct stDirecciones {
    bool arriba;
    bool abajo;
    bool izquierda;
    bool derecha;
    bool escape;
};

class Tunel : public HiloPantalla {
    public:
        Tunel(int anchoi, int ret) :
            HiloPantalla(hiloTunel), ancho(anchoi), centro(40), retardo(ret), cuenta(0), xn(40), yn(24) {
            hTeclas = CreateThread( 0, 0, hiloTeclado, (void*)this, 0, 0);
        }
        ~Tunel() {
            WaitForSingleObject(hTeclas, INFINITE);
            CloseHandle(hTeclas);
        }
        bool Escape() { return dir.escape; }
    private:
        void Mostrar() const;
        void Esperar() { Sleep(retardo); }
        void Siguiente();
        void BorrarNave();
        void MostrarNave();
        void ProcesaTeclas();
        bool Colision();
        void Explosion();
        int ancho;
        int centro;
        int retardo;
        int cuenta;
        int xn, yn;
        stDirecciones dir;
        HANDLE hTeclas;
        static DWORD WINAPI hiloTunel( void* );
        static DWORD WINAPI hiloTeclado( void* );
};
#endif
